<?php
// +----------------------------------------------------------------------
// | 发送腾讯云SMS  V3.0版本
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

// 本地环境没市区
date_default_timezone_set("PRC");

// 调用Demo
echo '<pre>';
var_dump(TencentSMS::run(15992431888, array(
	rand(1000, 9999)
)));

class TencentSMS {

	/**
	 * 云API密钥 上申请的标识身份 SecretId
	*/
	private static $uid = '';
	/**
	 * 云API密钥 上申请的标识身份 SecretKey
	*/
	private static $pwd = '';
	/**
	 * 短信签名内容，使用 UTF-8 编码，必须填写已审核通过的签名
	*/
	private static $sign = '';
	/**
	 * 模板ID
	*/
	private static $template_id = '';
	/**
	 * 添加应用后生成的实际SdkAppid，示例如1400006666
	*/
	private static $sdk_appid = '';
	/**
	 * 接口地址
	*/
	private static $api_url = 'https://sms.tencentcloudapi.com/';
	
	/**
	 * 调用入口
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.2.16 + 2020.10.27
	 * @deprecated 暂不启用
	 * @global 无
	 * @param string $mobile 手机号
	 * @param array $param 短信参数
	 * @return void
	*/
	public static function run($mobile, $param=array()) {
		if (self::phone_check($mobile) == 3) return false;
		// 只发国内的手机
		$mobile = '86'.$mobile;

		$data = array(
			'Action' => 'SendSms',
			'PhoneNumberSet.0'=> $mobile,
			'TemplateID'=> self::$template_id, 
			'Sign'=> self::$sign, 	
			'SmsSdkAppid'=> self::$sdk_appid, 
			'Nonce'=> mt_rand(111111,999999), // 随机数
			'Region' => 'ap-shanghai', // 上海市区
			'SecretId'=> self::$uid,
			'Timestamp'=> time(),
			'Version'=> '2019-07-11',
		);

		// 植入请求参数
		$i = 0;
		foreach ($param as $v) {
			$data['TemplateParamSet.'.$i] = $v;
			$i++;
		}
		// 生成签名
		$sign = self::tosign('POST', $data);
		$data['Signature'] = $sign;

		// 发包
		$result = self::_curl(self::$api_url, $data, 'POST');

		// 发送失败
		if (!isset($result['Response']['SendStatusSet'][0]['Code'])) return false;

		// 发送成功
		if ($result['Response']['SendStatusSet'][0]['Code'] == 'Ok') {
			return true;
		}

		// 发送失败
		return false;
	}

	/**
	 * 发送请求
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.2.16 + 2020.10.27
	 * @deprecated 暂不启用
	 * @global 无
	 * @param string $url 请求地址
	 * @param array $paramArray 请求参数
	 * @param string $method 请求类型
	 * @return mixed
	*/
	private static function _curl($url, $paramArray, $method = 'POST') {
		$ch = curl_init();
		if ($method == 'POST') {
			$paramArray = is_array( $paramArray ) ? http_build_query( $paramArray, null, '&', PHP_QUERY_RFC3986) : $paramArray;

			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, $paramArray);
		} else {
			$url .= '?' . http_build_query( $paramArray, null, '&', PHP_QUERY_RFC3986);
		}

		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_TIMEOUT,30);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		if (false !== strpos($url, "https")) {
			// 证书
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER,  false);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST,  false);
		}
		$resultStr = curl_exec($ch);

		$result = json_decode($resultStr, true);
		if (!$result){
			return $resultStr;
		}
		return $result;
	}

	/*
　　*@param  string  
　　*@return 
　　*/
	/**
	 * 判断是否国内电话
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.2.16 + 2020.10.27
	 * @deprecated 暂不启用
	 * @global 无
	 * @param string $phone   手机号字符串
	 * @return int 0中国移动，1中国联通  2中国电信  3未知
	*/
	private static function phone_check($phone){
		$isChinaMobile = "/^134[0-8]\d{7}$|^(?:13[5-9]|147|15[0-27-9]|178|18[2-478])\d{8}$/"; //移动方面最新答复
		$isChinaUnion = "/^(?:13[0-2]|145|15[56]|176|18[56])\d{8}$/"; //向联通微博确认并未回复
		$isChinaTelcom = "/^(?:133|153|177|173|18[019])\d{8}$/"; //1349号段 电信方面没给出答复，视作不存在

		if (preg_match($isChinaMobile, $phone)) {
			return 0;
		} else if(preg_match($isChinaUnion, $phone)) {
			return 1;
		} else if(preg_match($isChinaTelcom, $phone)) {
			return 2;
		}
		
		return 3;
	}

	/**
	 * 签名生成
	 * @todo 无
	 * @author 小黄牛
	 * @version v1.2.16 + 2020.10.27
	 * @deprecated 暂不启用
	 * @global 无
	 * @param string $pa 请求协议
	 * @param array $param 请求参数 
	 * @return void
	*/
	private static function tosign($pa, $param){
		ksort($param);
		$signStr = $pa."sms.tencentcloudapi.com/?";
		foreach ($param as $key => $value ) {
			$signStr = $signStr . $key . "=" . $value . "&";
		}
		$signStr = substr($signStr, 0, -1);
		
		$signature = base64_encode(hash_hmac("sha1", $signStr, self::$pwd, true));
	 
		return $signature;
	}	
}